<?php

// +-----------------------------------------------------------------------+
// |                             functions                                 |
// +-----------------------------------------------------------------------+

global $user, $template, $lang, $conf, $im_priority;



function counter_compare($a, $b)
{
  if ($a['counter'] == $b['counter'])
  {
    return id_compare($a, $b);
  }

  return ($a['counter'] < $b['counter']) ? +1 : -1;
}

function id_compare($a, $b)
{
  return ($a['id'] < $b['id']) ? -1 : 1;
}

check_status(ACCESS_GUEST);

// +-----------------------------------------------------------------------+
// |                        tag cloud construction                         |
// +-----------------------------------------------------------------------+

// find all tags available for the current user
$tags = get_available_tags();

// we want only the first most represented tags, so we sort them by counter
// and take the first tags
usort($tags, 'counter_compare');
$tags = array_slice($tags, 0, $conf['full_tag_cloud_items_number']);

// depending on its counter and the other tags counter, each tag has a level
$tags = add_level_to_tags($tags);

// we want tags diplayed in alphabetic order
usort($tags, 'name_compare');

// display sorted tags
if (defined('typetags_TABLE'))
{
  $query = '
    SELECT  t.id , tt.color
    FROM ' . typetags_TABLE . ' AS tt
    INNER JOIN ' . TAGS_TABLE . ' AS t
    ON  t.id_typetags = tt.id
    WHERE  t.id_typetags IS NOT NULL ;
  ';
    
  $result = pwg_query($query);
  $tagsColor = array();

  while ($row = mysql_fetch_assoc($result))
  {
    $tagsColor += array($row['id'] => $row['color']);
  }
}

foreach ($tags as $tag)
{
  if (isset($tagsColor[$tag['id']]))
  {
    $tag['name'] = '<span style="color:' . $tagsColor[$tag['id']] . '">' . $tag['name'] . '</span>';
  }
  
  $template->assign_block_vars(
    'tag',
    array(
      'URL' => make_index_url(
        array(
          'tags' => array($tag),
          )
        ),

      'NAME' => $tag['name'],
      'TITLE' => $tag['counter'],
      'CLASS' => 'tagLevel'.$tag['level'],
      )
    );
}

// Emplacement du bloc
if (isset($im_priority))
{
  $insert_before = $im_priority['TagsOnIndex'] < $im_priority['Categories'] ? '<div class="titrePage">' : '</div> <!-- content -->';
}
else
{
  $insert_before = '</div> <!-- content -->';
}

$template->loadfile('index');
$template->uncompiled_code['index'] = str_replace($insert_before, '{TAGSONINDEX_CONTENT}' . $insert_before, $template->uncompiled_code['index']);

$template->set_filenames(array('nbc_tagsonindex' => NBC_TAGSONINDEX_PATH.'nbc_tagsonindex.tpl'));
$template->assign_var_from_handle('TAGSONINDEX_CONTENT', 'nbc_tagsonindex');

?>
